SCM Version:  0.3
/*/*/*/*/*/DH 1/*/*/*/*/*/
Current Version:  1.0
Parent Version:  -1
Previous Version:  1.0
Archive Date:  63259625887.000000
Client Date:  63259462120.000000
File Size:  4344
File CRC:  4272203519
Delta Size:  4344
Delta CRC:  4272203519
Delta Flags:  1
Action:  1
Author:  Administrator
Action Date:  63259625887.000000
Comments:  $NULL$
*/*/*/*/*/*DH 2*/*/*/*/*/*
//'Copyright 2004 Seapine Software, Inc. All rights reserved.
//
//IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
//in consideration of your agreement to the following terms, and your use, installation,
//modification or redistribution of this Software constitutes acceptance of these terms.
//If you do not agree with these terms, please do not use, install, modify or redistribute
//this Software.
//
//In consideration of your agreement to abide by the following terms, and subject to these
//terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
//this original Seapine software (the Software), to use, reproduce, modify and redistribute
//the Software, with or without modifications, in source and/or binary forms; provided that
//if you redistribute the Software in its entirety and without modifications, you must retain
//this notice and the following text and disclaimers in all such redistributions of the Software.
//Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
//or promote products derived from the Software without specific prior written permission from
//Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
//implied, are granted by Seapine herein, including but not limited to any patent rights that
//may be infringed by your derivative works or by other works in which the Software may be
////incorporated.
//
//The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
//EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
//MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
//OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS. 
//
//IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
//DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
//LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
//REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
//UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
//IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//******************************************************************************

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Threading;

namespace TTPRSSFeed
{
	public class Thread
	{
		private MainDlg m_formDialog;
		private ttsoapcgi m_cgiEngine;
		private System.Threading.Timer m_timer;
		private RSSFeed m_feeder;
		private string m_strDatabase;
		private long m_lInterval;

		public Thread(MainDlg p_formDialog,
			ttsoapcgi p_cgiEngine,
			string p_strLocalPath,
			string p_strDatabase,
			string p_strUsername,
			string p_strPassword,
			long p_lTimerInterval)
		{
			m_formDialog = p_formDialog;
			m_cgiEngine = p_cgiEngine;
			m_strDatabase = p_strDatabase;
			m_lInterval = p_lTimerInterval;

			m_feeder = new RSSFeed( p_strLocalPath, p_strDatabase, p_strUsername, p_strPassword);
		}

		public void Handler()
		{
			AutoResetEvent autoEvent = new AutoResetEvent(false);
			TimerCallback timerDelegate = 
				new TimerCallback(this.timerEvent);

			// -meh. Let's wait 10 seconds before our first rss feed.
			m_timer = new Timer(timerDelegate, autoEvent, 10000, Convert.ToInt32(m_lInterval) * 60 * 1000);
		}

		private bool launchFeeder()
		{
			m_formDialog.writeStatus("Updating rss feed for '" + m_strDatabase + "' database...");

			long lUpdateCnt = 0;
			string strError = "";
			bool f = m_feeder.generateRSSFeed( m_cgiEngine, ref lUpdateCnt, ref strError);

			if (f)
				m_formDialog.writeStatus( "Successfully added " + Convert.ToString(lUpdateCnt, 10) + " items from '" + m_strDatabase + "' database");
			else
				m_formDialog.writeStatus( "Update of '" + m_strDatabase + "' database failed: " + strError);

			return (f);
		}

		public void Abort() { m_timer.Dispose(); m_timer = null; }

		public void timerEvent(Object stateInfo)
		{
			if (launchFeeder()) { m_formDialog.writeRefresh(); }
		}
	}
}#$#$#$#$#$#DF 1#$#$#$#$#$#
Footer for delta
Current Version:  1.0
$#$#$#$#$#$DF 2$#$#$#$#$#$
